

// remove html tags from string.
String.prototype.removeTags = function(func){
  return this.replace(/<.*?>/g, "");
}


// returns a string containing a concatenation of all the text nodes in the element 
Element.prototype.getText = function(){
	retval = "";
		for (var n=0, e; e=this.childNodes[n]; n++) {
			if (e.nodeType == Node.TEXT_NODE) retval += e.nodeValue;
		}
		return retval;
}

// remoces children
Element.prototype.removeChildren = function(){
		while(this.firstChild){
			this.removeChild(this.firstChild)
		}
}

// make an object the enclosing object of a method call.
Function.prototype.enclose = function(object){
	var fun = this;
	return function() {
		fun.apply(object, arguments);
	}
}
