// instance variables
var pages = ["top favourites","top rated","recently added","most viewed today","recently featured"];
var skins = ["blue","white","green"];
var pageCounter = 0;
var skinCounter = 0;
var maxTitleLength = 50;

// runs when the widget is loaded
window.addEventListener("load",function(ev){

	window.addEventListener('keypress',function(ev){
	    if (ev.keyCode == 39){
		gotoQuire(1);
	    };
	},false);
l
	window.addEventListener('keypress',function(ev){
	    if (ev.keyCode == 37){
		gotoQuire(-1);
	    };
	},false);

	window.addEventListener("keypress",function(ev){
		if (ev.keyCode == 9){
			changeSkin();
		}
	},false);

	document.getElementById('close').addEventListener('click',function(ev){
			document.getElementById('video').className = "hide";
			document.getElementById(pages[pageCounter]).className = "show";
			document.getElementById('ueber').className = "content";
			document.getElementById('logo').className = "logo";
			document.getElementById('search').className = "search";
			document.getElementById('title').className = "show";
	},false);

	loadRSSfeeds();
}, false );

// start all feeds
function loadRSSfeeds(){
	// dit kan 10 keer mooier, maar dat is voor later zorg
	var feed0 = new RSSFetcher("http://youtube.com/rss/global/top_favorites.rss");
	var feed1 = new RSSFetcher("http://youtube.com/rss/global/top_rated.rss");
	var feed2 = new RSSFetcher("http://youtube.com/rss/global/recently_added.rss");
	var feed3 = new RSSFetcher("http://youtube.com/rss/global/top_viewed_today.rss");
	var feed4 = new RSSFetcher("http://youtube.com/rss/global/recently_featured.rss");
	var feedWidget0 = new FeedWidget(feed0, 'top favourites');
	var feedWidget1 = new FeedWidget(feed1, 'top rated');
	var feedWidget2 = new FeedWidget(feed2, 'recently added');
	var feedWidget3 = new FeedWidget(feed3, 'most viewed today');
	var feedWidget4 = new FeedWidget(feed4, 'recently featured');
	
	// zet de titel goed
	document.getElementById('title').textContent = pages[pageCounter];
}



// RSS fetching class.
function RSSFetcher(url) {
	this.url = url;
	this.errorListeners = [];
	this.updateListeners = [];
	this.conn = null;
	this.feedName = "";
	this.feedItems = [];
	this.updateTime = null;
	this.updateTimer = 0;
	this.updateInterval = 6000; // 1 minutes default refresh time

	//Return feed items  
	this.getFeedItems = function() {
		return this.feedItems;
	}
  
	// Return the time the feed was updated
	this.getUpdateTime = function() {
		return this.updateTime;
	}
	
	// add an event listener for update events
	this.addUpdateEventListener = function(func) {
		this.updateListeners.push(func);
  	}
  
	// Add an event listener for error events
	this.addErrorEventListener = function(func) {
		this.errorListeners.push(func);    
  	}

	// notify all event listeners of an update
	this.notifyUpdateListeners = function(){
		for (var n=0, e; e=this.updateListeners[n]; n++){
			e(this);
		}
	}

	// fetch data from RSS
	this.update = function() {
		if (this.updateTimer) {
			cancelTimeout(this.updateTimer);
		}
		this.conn = new XMLHttpRequest();
		this.conn.open('get', this.url, true);
		this.conn.onreadystatechange = this.xhrCB.enclose(this);
		this.conn.send(null);
		setTimeout(this.update.enclose(this), this.updateInterval);
	}


	// parse rss feed into the index file
	this.parseItems = function(xml) {
		var items = xml.getElementsByTagName('item');
		var retval = [];
		for (var n=0, e; e=items[n]; n++) {
			item = {};
			item.title = e.getElementsByTagName('title')[0].getText().removeTags();
			// item.title = item.title.replace(/&amp;/, "&"); //GROTER MAKEN
			item.thumb = e.getElementsByTagName('thumbnail')[0].getAttribute('url');
			item.video = e.getElementsByTagName('enclosure')[0].getAttribute('url');
			item.link = e.getElementsByTagName('link')[0].getText();
			item.credit = e.getElementsByTagName('credit')[0].getText().removeTags();
			// item.description = e.getElementsByTagName('credit')[0].getText();
			// item.description = e.getElemetnsByTagNam('thumbnail')[0].getText();
			retval.push(item);
		}
		return retval;
	}


	// callback to the xmlhttprequest
	this.xhrCB = function() {
		if (this.conn.readyState==4) {
			if (this.conn.status==200 || this.conn.status==304){
				this.feedItems = this.parseItems(this.conn.responseXML);
				this.updateTime = new Date();      
			        this.notifyUpdateListeners();
			} else {
				// notifyErrorListeners();
			}
		}
	}    
} //end of class

// main class
function FeedWidget(feed, target){  
   	this.target = target;
	// update the list of news items.
	this.updateNewsList = function() {
		var items = this.feed.getFeedItems();
		items = items.slice(0, this.itemCount);
		var container = document.getElementById(target);
		container.removeChildren();
		
		var list = new Array(30);

		for (var n=0, e; e=items[n]; n++) {
			var li = document.createElement('li');
			li.newsItem = e;
			link = document.createElement('a');
			thumbnail = document.createElement('img');
			var text = e.title;
			if(text.length > maxTitleLength){
				text = text.slice(0,maxTitleLength) + "...";
			}
			link.appendChild(document.createTextNode(text));
			// link.href=e.link;
			// link.target="_blank";
			link.id=e.video;
			thumbnail.src = e.thumb;
			thumbnail.width = "38";
			thumbnail.height = "38";
			li.appendChild(thumbnail);
			li.appendChild(document.createTextNode("  "));
			li.appendChild(link);
			container.appendChild(li);

			//add event listeners
			var film = e.video;
			document.getElementById(film).addEventListener('click',function(ev){
				document.getElementById(pages[pageCounter]).className = "hide";
				document.getElementById('logo').className = "hide";
				document.getElementById('search').className = "hide";
				document.getElementById('ueber').className = "hide";
				document.getElementById('title').className = "show";
				var temp = document.getElementById('video_player');
				temp.setAttribute('src', this.id );
				document.getElementById('video').appendChild(temp);
				document.getElementById('video').className = "show";
			},false);
		}
		this.currentHover=null;
  	}

	this.blindStatus = false;
	this.updateInterval = 1;   // in minutes
	this.itemCount = 20;         // number of items to show by defaults.
	this.viewedItems = []
	this.feed = feed;
	this.feed.addUpdateEventListener(this.updateNewsList.enclose(this));

	/* Hook up all our event listeners */
	var newsContainer = document.getElementById(target);
	
	// start with an update
	this.feed.update();  
}

// changes the skin
function changeSkin(){
	var d = document.getElementById('container');
	if (++skinCounter == skins.length){ 
		skinCounter = 0;
	} 
	d.className = skins[skinCounter];
}

// changes the quire for given direction d, 1 = next, -1 = previous
function gotoQuire(d){
	this.d = d;
	document.getElementById(pages[pageCounter]).className = "hide";
	pageCounter = pageCounter + d;
	if (pageCounter == pages.length){ 
		pageCounter = 0;
	} 
	if (pageCounter == -1){
		pageCounter = pages.length-1;
	}
	document.getElementById(pages[pageCounter]).className = "poepinjehoofd";
	document.getElementById('title').textContent = pages[pageCounter];
}

